GLOBAL.STRINGS.NAMES.NECRONOMICON = "Necronomicon"
GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.NECRONOMICON = "Ex-Mortis."
GLOBAL.STRINGS.CHARACTERS.GENERIC.NOFUEL = "Klaatu Barada Nikto!"
GLOBAL.STRINGS.CHARACTERS.GENERIC.NOSANITY = "That would be a insane thing to do!"

PrefabFiles = {
	"wesna",
	"choppy",
	"necronomicon",
}  

Assets = {
    Asset( "IMAGE", "images/saveslot_portraits/wesna.tex" ),
    Asset( "ATLAS", "images/saveslot_portraits/wesna.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/wesna.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wesna.xml" ),

    Asset( "IMAGE", "images/selectscreen_portraits/wesna_silho.tex" ),
    Asset( "ATLAS", "images/selectscreen_portraits/wesna_silho.xml" ),
	
	Asset( "ATLAS", "images/inventoryimages/necronomicon.xml" ),
	Asset( "IMAGE", "images/inventoryimages/necronomicon.tex" ),

    Asset( "IMAGE", "bigportraits/wesna.tex" ),
    Asset( "ATLAS", "bigportraits/wesna.xml" ),
--for minimap
    Asset("IMAGE", "images/wesna.tex"),
	Asset("ATLAS", "images/wesna.xml"),
	
	Asset("IMAGE", "images/inventoryimages/necronomicon.tex"),
	Asset("ATLAS", "images/inventoryimages/necronomicon.xml"),
}

--Add the new atlas
AddMinimapAtlas("images/wesna.xml")
AddMinimapAtlas("images/inventoryimages/necronomicon.xml")

local STRINGS = GLOBAL.STRINGS
local TUNING = GLOBAL.TUNING
local ACTIONS = GLOBAL.ACTIONS


-- [[ choppy BEGIN ]] -- 

GLOBAL.STRINGS.CHOPPY_NAMES = { "Choppy" }

STRINGS.CHARACTERS.GENERIC.DESCRIBE.CHOPPY = { GENERIC = "Choppy!" }
STRINGS.CHARACTERS.WX78.DESCRIBE.CHOPPY = "WOOF"
STRINGS.CHARACTERS.WILLOW.DESCRIBE.CHOPPY = "I sense the fire within."
STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.CHOPPY = "I never read about this before..."
STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.CHOPPY = "Good boy!"
STRINGS.CHARACTERS.WENDY.DESCRIBE.CHOPPY = "How strange, a loving monster."
STRINGS.CHARACTERS.CHOPPY = {
	COMBAT_QUIT = {
		GENERIC = " ",
	}
}

-- add leader component to hounds
function HF_addleadercomponenttoprefab(inst)
	if not inst.components.leader then
		inst:AddComponent("leader")
	end
	inst:AddTag("realhound")
end
AddPrefabPostInit("hound", HF_addleadercomponenttoprefab)
AddPrefabPostInit("firehound", HF_addleadercomponenttoprefab)
AddPrefabPostInit("icehound", HF_addleadercomponenttoprefab)

-- [[ SHARED OVERWRITES BEGIN ]] --

--overwrite standard teleport to not teleport followers with component unteleportable
function teleporterpostinit(inst)

	inst.Activate = function(self, doer)
	--begin core
		if self.targetTeleporter == nil then
			return
		end
		
		if self.onActivate then
			self.onActivate(self.inst, doer)
		end

		if self.onActivateOther then
			self.onActivateOther(self.inst, self.targetTeleporter, doer)
		end
		
		
		self:Teleport(doer)
		
		if doer.components.leader then
			for follower,v in pairs(doer.components.leader.followers) do
				if not follower.components.unteleportable then
					self:Teleport(follower)
				end
			end
		end
		
		--special case for the chester_eyebone: look for inventory items with followers
		if doer.components.inventory then
			
			for k,item in pairs(doer.components.inventory.itemslots) do
				if item.components.leader then
					for follower,v in pairs(item.components.leader.followers) do
						self:Teleport(follower)
					end
				end
			end
			
			for k,equipped in pairs(doer.components.inventory.equipslots) do
				if equipped and equipped.components.container then
					local container = equipped.components.container
					for j,item in pairs(container.slots) do
						if item.components.leader then
							for follower,v in pairs(item.components.leader.followers) do
								self:Teleport(follower)
							end
						end
					end
				end
			end
			
		end
	-- end core
	end

end

AddComponentPostInit("teleporter", teleporterpostinit)

--overwrite GIVE action to have higher priority than attack=2
ACTIONS.GIVE.priority = 4


-- overwrite getsavefollowers to ignore followers with unteleportable
GLOBAL.SaveIndex.GetSaveFollowers = function (self, doer)
	local followers = {}

	if doer.components.leader then
		for follower,v in pairs(doer.components.leader.followers) do
			if follower.components.followersitcommand and follower.components.followersitcommand.stay == false then
				local ent_data = follower:GetPersistData()
				table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
				follower:Remove()
			elseif not follower.components.followersitcommand and not follower.components.unteleportable then
				local ent_data = follower:GetPersistData()
				table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
				follower:Remove()
			end
		end
	end

	--special case for the chester_eyebone: look for inventory items with followers
	if doer.components.inventory then
		for k,item in pairs(doer.components.inventory.itemslots) do
			if item.components.leader then
				for follower,v in pairs(item.components.leader.followers) do
					local ent_data = follower:GetPersistData()
					table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
					follower:Remove()
				end
			end
		end

		-- special special case, look inside equipped containers
		for k,equipped in pairs(doer.components.inventory.equipslots) do
			if equipped and equipped.components.container then
				local container = equipped.components.container
				for j,item in pairs(container.slots) do
					if item.components.leader then
						for follower,v in pairs(item.components.leader.followers) do
							local ent_data = follower:GetPersistData()
							table.insert(followers, {prefab = follower.prefab, data = follower:GetPersistData()})
							follower:Remove()
						end
					end
				end
			end
		end
	end

	if self.data~= nil and self.data.slots ~= nil and self.data.slots[self.current_slot] ~= nil then
	 	self.data.slots[self.current_slot].followers = followers
	end	
end


-- strings! Any "WOD" below would have to be replaced by the prefab name of your character.
local require = GLOBAL.require
GLOBAL.STRINGS.CHARACTERS.WESNA = require "speech_wesna"

-- The character select screen lines
-- note: these are lower-case character name
GLOBAL.STRINGS.CHARACTER_TITLES.wesna = "The Lost Student"
GLOBAL.STRINGS.CHARACTER_NAMES.wesna = "Wesna"  -- Note! This line is especially important as some parts of the game require
                                            -- the character to have a valid name.
GLOBAL.STRINGS.CHARACTER_DESCRIPTIONS.wesna = "*Has a Unique Book.\n*Can Summon a Friend to Fight.\n*Hears Voices."
GLOBAL.STRINGS.CHARACTER_QUOTES.wesna = "\"Come Out Choppy!.\""

-- You can also add any kind of custom dialogue that you would like. Don't forget to make
-- categores that don't exist yet using = {}
-- note: these are UPPER-CASE charcacter name
STRINGS.CHARACTERS.WESNA = require "speech_wesna"


-- Let the game know Wod is a male, for proper pronouns during the end-game sequence.
-- Possible genders here are MALE, FEMALE, or ROBOT
table.insert(GLOBAL.CHARACTER_GENDERS.FEMALE, "wesna")


AddModCharacter("wesna")

AddGamePostInit(load)

package = GLOBAL.package
package.path = "mods\\wesna\\scripts\\?.lua;"..package.path
