local HoundTypes = Class(function(self, inst)
    	self.inst = inst
	self.currenttype = "normal"
	self.inst:ListenForEvent("death", function(inst,data) 
		if self.currenttype == "blue" then
			inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/icehound_explo", "explosion")
		end
		if self.currenttype == "red" then
			inst.SoundEmitter:PlaySound("dontstarve/creatures/hound/firehound_explo", "explosion")
		end
	end)
	self.inst:ListenForEvent("onhitother", function (inst, data)
		if self.currenttype == "red" then
			if math.random(100) < 10 then
    -- [[Begin copy-paste ]]
    local target = data.target
    if target.components.burnable and not target.components.burnable:IsBurning() then
        if target.components.freezable and target.components.freezable:IsFrozen() then           
            target.components.freezable:Unfreeze()            
        else            
            target.components.burnable:Ignite()
	    target.components.burnable:SetBurnTime(5)
        end   
    end

    if target.components.freezable then
        target.components.freezable:AddColdness(-1)
        if target.components.freezable:IsFrozen() then
            target.components.freezable:Unfreeze()            
        end
    end
    -- [end copy-paste]]
			end
		end
		if self.currenttype == "blue" then
			if math.random(100) < 10 then
    -- [[Begin copy-paste ]]
    local target = data.target
    if target.components.freezable then
        target.components.freezable:AddColdness(4, 3)
        target.components.freezable:SpawnShatterFX()
    end
   if target.components.burnable and target.components.burnable:IsBurning() then
        target.components.burnable:Extinguish()
    end
    -- [end copy-paste]]
    			end
		end

	end)
end)

function HoundTypes:MakeMeBlue()
	self.inst.components.houndtypes:LoadMeBlue()
	local fx = SpawnPrefab("maxwell_smoke")
        fx.Transform:SetPosition(self.inst.Transform:GetWorldPosition())
	self.inst.sg:GoToState("eat")
end

function HoundTypes:MakeMeRed()
	self.inst.components.houndtypes:LoadMeRed()
	local fx = SpawnPrefab("maxwell_smoke")
        fx.Transform:SetPosition(self.inst.Transform:GetWorldPosition())
	self.inst.sg:GoToState("eat")

end

function HoundTypes:LoadMeBlue()
	self.currenttype = "blue"
	self.inst.AnimState:SetBuild("hound_ice")	
	self.inst.components.lootdropper:AddChanceLoot("bluegem", 0.5)
	self.inst.components.health:SetMaxHealth(400)
	self.inst.components.combat:SetDefaultDamage(40)
end

function HoundTypes:LoadMeRed()
	self.currenttype = "red"
	self.inst.AnimState:SetBuild("hound_red")
	self.inst.components.lootdropper:AddChanceLoot("redgem", 0.5)
	self.inst.components.health:SetMaxHealth(400)
	self.inst.components.combat:SetDefaultDamage(40)
	self.inst.components.health.fire_damage_scale = 0
	self.inst:RemoveComponent("burnable")
	self.inst:RemoveComponent("propagator")
	
end

function HoundTypes:OnSave()
	if self.currenttype ~= "normal" then
		return { currenttype = self.currenttype }
	end
end

function HoundTypes:OnLoad(data)
	if data.currenttype then
		if data.currenttype == "red" then
			self.inst.components.houndtypes:LoadMeRed()
		end
		if data.currenttype == "blue" then
			self.inst.components.houndtypes:LoadMeBlue()
		end
	end
end
		


return HoundTypes
